#include <stdio.h>
#include <stdlib.h>
#include <string.h>

FILE* AVF;
FILE* MBF;

void pause()
{
	while(getchar()!='\n');
}

int main(int argc,char** argv)
{
	int i,l,mode,m;
	char c,d,h,w;

	if(argc<2)
	{
		printf("Usage: avf2mbf <avf> [mbf]\n");
		pause();
		return 0;
	}
	
	AVF=fopen(argv[1],"rb");
	
	if(!AVF)
	{
		printf("Couldn't open avf\n");
		return 1;
	}
	if(argc<3) 
	{
		char* mbf;
		l=strlen(argv[1])+1;
		mbf=(char*)malloc(sizeof(char)*l);
		for(i=0;i<l-4;++i) mbf[i]=argv[1][i];
		mbf[l-4]='m';mbf[l-3]='b';mbf[l-2]='f';mbf[l-1]=0;
		MBF=fopen(mbf,"wb+");
		free(mbf);
	}
	else
		MBF=fopen(argv[2],"wb+");		
	if(!MBF)
	{
		printf("Couldn't open mbf\n");
		return 1;
	}
	
	c=fgetc(AVF);					// version
	for(i=0;i<4;++i) c=fgetc(AVF);	// meaningless bytes
	
	c=fgetc(AVF);					// mode
	mode=c-2;
	if(mode==1)	// beg
	{
		w=h=8;m=10;
	}
	else if(mode==2) // int
	{
		w=h=16;m=40;
	}
	else if(mode==3) // exp
	{
		w=30;h=16;m=99;
	}
	else if(mode==4) // cus
	{
		w=(c=fgetc(AVF))+1;
		h=(c=fgetc(AVF))+1;
		m=(c=fgetc(AVF));
		m=m*256+(c=fgetc(AVF));
	}
	else return 1;
	
	fprintf(MBF,"%c%c",w,h);
	h=m/256;w=m%256;
	fprintf(MBF,"%c%c",h,w);
	for(i=0;i<m;++i)
	{
		c=fgetc(AVF)-1;
		d=fgetc(AVF)-1;
		fprintf(MBF,"%c%c",d,c);
	}

	fclose(AVF);fclose(MBF);
	
	return 0;
}
